<?php

class Template {
	
	// テンプレートディレクトリ
	private $dir;
	
	//---------------------------------------------------------
	//  コンストラクタ
	//---------------------------------------------------------
	
	public function __construct($workDir) {
		
		// ディレクトリ名を設定
		$this->dir = $workDir . '/templates/htm';
		
	}
	
	//---------------------------------------------------------
	//  ディレクトリを再設定
	//---------------------------------------------------------
	
	public function setDir($dir) {
		
		// ディレクトリ名を設定
		$this->dir = $dir;
		
	}
	
	//---------------------------------------------------------
	//  テンプレートの出力
	//---------------------------------------------------------
	
	public function show($html, $vars = array()) {
		
		// 連想配列を変数に展開
		extract($vars);
		
		// テンプレートを出力
		eval("echo <<<_HTML_\n$html\n_HTML_;\n");
		
	}
	
	//---------------------------------------------------------
	//  テンプレートの出力（戻り値）
	//---------------------------------------------------------
	
	public function res($html, $vars = array()) {
		
		// 連想配列を変数に展開
		extract($vars);
		
		// テンプレートを変数にセット
		eval("\$eval = <<<_HTML_\n$html\n_HTML_;\n");
		
		// テンプレートを返す
		return $eval;
		
	}
	
	//---------------------------------------------------------
	//  テンプレートファイルの読み込み
	//---------------------------------------------------------
	
	public function read($file, $delimiter = '<!---->') {
		
		// テンプレートファイル名を整形
		$tmplHtm = $this->dir . '/' . $file;
		
		// テンプレートファイルが読み込めない時は終了
		if (!is_readable($tmplHtm) || !filesize($tmplHtm)) {
			return false;
		}
		
		// テンプレートを読み込み
		$html = @file_get_contents($tmplHtm);
		
		// デリミタが存在する時は分割してテンプレートを返す
		if ($delimiter) {
			return explode($delimiter, $html);
		}
		
		// テンプレートを返す
		return $html;
		
	}
	
}

